import re
from typing import Optional, Tuple

from lxml import etree


def clean_category(raw: str) -> str:
    spaced = lambda z: re.compile(r"\s*".join(i for i in z), re.I | re.X)

    if spaced("decision").search(raw):
        return f"Decision"

    elif spaced("resolution").search(raw):
        return f"Resolution"

    return f"Unknown"


def spot_category(text: str) -> Tuple[Optional[str], Optional[str]]:

    html = etree.HTML(text)

    CATEGORY_LOCATION = "//center[1]/h3/text()[last()]"

    spotted = html.xpath(CATEGORY_LOCATION)[0]

    text_category = str(spotted)

    return text_category, clean_category(text_category)
